package sk.upjs.ics.novotnyr.android.calllog;

import java.util.Date;

import android.database.Cursor;
import android.provider.CallLog;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.SimpleCursorAdapter.ViewBinder;

public class CallLogEntryViewBinder implements ViewBinder {
	@Override
	public boolean setViewValue(View view, Cursor cursor, int columnIndex) {
		if(CallLog.Calls.DATE.equals(cursor.getColumnName(columnIndex))) {
			TextView textView = (TextView) view;
			
			String value = new Date(cursor.getLong(columnIndex)).toLocaleString();
			textView.setText(value);
			return true;
		}
		if(CallLog.Calls.TYPE.equals(cursor.getColumnName(columnIndex))) {
			ImageView imageView = (ImageView) view;
			if(CallLog.Calls.TYPE.equals(cursor.getColumnName(columnIndex))) {
				int type = cursor.getInt(columnIndex);
				imageView.setImageResource(getCallLogEntryImage(type));
				return true;
			}			
		}
		return false;
	}

	private int getCallLogEntryImage(int type) {
		switch (type) {
		case CallLog.Calls.INCOMING_TYPE:
			return android.R.drawable.sym_call_incoming;
		case CallLog.Calls.OUTGOING_TYPE:
			return android.R.drawable.sym_call_outgoing;
		case CallLog.Calls.MISSED_TYPE:
			return android.R.drawable.sym_call_missed;
		}
		return 0;
	}

}
