package sk.upjs.ics.novotnyr.android.calllog;

import android.view.ContextMenu.ContextMenuInfo;
import android.view.MenuItem;
import android.widget.AdapterView;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.ListAdapter;

public abstract class ContextItemUtils {
	public static final String TAG = ContextItemUtils.class.getName();

	public static <T> T getContextItemObject(ListAdapter listAdapter, MenuItem item, Class<T> clazz) throws ClassCastException {
		return getContextItemObject(listAdapter, item.getMenuInfo(), clazz);
	}

	public static <T> T getContextItemObject(ListAdapter listAdapter, ContextMenuInfo menuInfo, Class<T> clazz) throws ClassCastException {
		if(menuInfo instanceof AdapterContextMenuInfo) {
			AdapterView.AdapterContextMenuInfo contextMenuInfo = (AdapterContextMenuInfo) menuInfo;
			@SuppressWarnings("unchecked")
			T object = (T) listAdapter.getItem(contextMenuInfo.position);
   			return object;
		} else {
			throw new ClassCastException("Menu info object is should be a descendant of AdapterContextMenuInfo.");
		}
	}
	
}
