package sk.upjs.ics.novotnyr.android.calllog;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.CallLog;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.SimpleCursorAdapter;

public class MainActivity extends ListActivity {
	private static final int MENU_ITEM_ID_DIAL = Menu.FIRST + 1;

	private static final int MENU_ITEM_ID_SMS = Menu.FIRST + 2;

	private static final String TAG = MainActivity.class.getName(); 
	
	private static final String[] NO_PROJECTION = null;
	
	private static final String NO_SELECTION = null;

	private static final String[] NO_SELECTION_ARGS = null;

	private static final String NO_SORT_ORDER = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		String[] from = { CallLog.Calls.NUMBER, CallLog.Calls.DATE, CallLog.Calls.TYPE };
		int[] to = { R.id.calllog_text1, R.id.calllog_text2, R.id.calllog_image};

		Uri contentProviderUri = CallLog.Calls.CONTENT_URI;
		
		Cursor cursor = getContentResolver().query(contentProviderUri, NO_PROJECTION, NO_SELECTION, NO_SELECTION_ARGS, NO_SORT_ORDER);
		startManagingCursor(cursor);
		
		SimpleCursorAdapter adapter = new SimpleCursorAdapter(this, R.layout.list_calllog, cursor, from, to);
		adapter.setViewBinder(new CallLogEntryViewBinder());
		setListAdapter(adapter);
		
		registerForContextMenu(getListView());
	}
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View view, ContextMenuInfo menuInfo) {
	    if (view.getId() == this.getListView().getId()) {
    		menu.setHeaderTitle("Call Entry");

	    	menu.add(Menu.NONE, MENU_ITEM_ID_DIAL, Menu.NONE, "Dial");
    		menu.add(Menu.NONE, MENU_ITEM_ID_SMS, Menu.NONE, "SMS");
	    }
	}
	
	@Override
	public boolean onContextItemSelected(MenuItem item) {
		Cursor cursor = ContextItemUtils.getContextItemObject(getListAdapter(), item, Cursor.class);
		if(cursor == null) {
			Log.e(TAG, "No Cursor data for item " + item);
			return false;
		}
		String phoneNumber = cursor.getString(cursor.getColumnIndex(CallLog.Calls.NUMBER));
		
		switch(item.getItemId()) {
		case MENU_ITEM_ID_DIAL:
			Intent callIntent = new Intent(Intent.ACTION_CALL, Uri.fromParts("tel", phoneNumber, null));
		    startActivity(callIntent);

			return true;

		case MENU_ITEM_ID_SMS:
			Intent smsIntent = new Intent(Intent.ACTION_VIEW, Uri.fromParts("sms", phoneNumber, null));
			startActivity(smsIntent);
			return true;
		default:
			return super.onContextItemSelected(item);
		}
	}

}
